public void exit() { // disable quit on Esc press
  if (key == ESC) return;
  super.exit();
}

void mouseDragged() {
  mousePressed();
}

void mousePressed() {  // jump to nearest 'frame'
  if (mouseY > ysplit) return;
  int x = mouseX/15*10;

  for (int i = 0; i < ninja.length; i++) {
    if (goleft == 0) {
      if (ninja[i].x >= mouseX) {x = i; break;}
    } else {
      if (ninja[i].x <= mouseX) {x = i; break;}
    }
  }

  Fadvance(x-f);
}

void mouseWheel(MouseEvent e) {
  if (e.getCount() > 0) MoveEdit(-1);
  else MoveEdit(+1);
  ResetVars();
}

void keyPressed() {
  switch (key) {
    case 'z': compare = !compare; break; // broke this at some point
                                         // but haven't needed it anyway 
    case 'w': Fadvance(+10); break;
    case 's': Fadvance(-10); break;
    case 'a': Fadvance(-1); break;
    case 'd': Fadvance(+1); break;

    case 'f': BirdLo(false); break;
    case 'r': BirdLo(true); break;
  }

  if (key == CODED) {
    switch (keyCode) {
      case UP:
      case RIGHT: BirdLo(true); break;
      case DOWN:
      case LEFT:  BirdLo(false); break;
    }
  }
}

void keyReleased() {
  switch (key) {
    case 'g': Bounce(f); break;
    case 'b': unBounce(f); break;
    case 't': Shift(-1); break;
    case 'y': Shift(+1); break;
    case 'v': ninja[f].z = 0x100; break;
    case 'q': MoveEdit(-1); break;
    case 'e': MoveEdit(+1); break;
    case 'h': target = f; break;

    case 'x': magtog = !magtog; return;
    case 'c': ImgCopy(current); return;
    case '=': ImgCopy(original); return;
    case 'k': ScreenShot(); return;
    case  15: selectInput("", "fileSelected"); return; // = Ctrl+O
  }
  ResetVars();
}

void Fadvance(int n) {
  f = constrain(f+=n, 0, ninja.length-1);
}

void ImgCopy(PImage img) {
  previous = img.copy();
  previous.updatePixels();
  println("copied");
}

void FirstCopy() {
  ImgCopy(current);
  original = current.copy();
  original.updatePixels();
  init = false;
}

void ScreenShot() {
  current.save("/data/"+frame+"-"+hex(birdxlo>>4, 1)+".png");
  println("saved");
}

void Bounce(int b) {  // set x speed to 1 for 13 frames (ideal boost to platform)
  for (int i = b+12; i >= b; i--) {
    if (i >= 0 && i < ninja.length) ninja[i].z = 0x100;
  }
  ninja[b-1].z = 0x180;
  ninja[b+13].z = 0x180;
}

void unBounce(int b) {
  for (int i = b+20; i >= b-1; i--) {
    if (i >= 0 && i < ninja.length) ninja[i].z = 0x180;
  }
  Fadvance(+1);
}

void Shift(int b) {
  int s = 24;
  float[] z = new float[s];
  // shouldn't have used PVector.z like this
  for (int i = 0; i < s; i++)
    if (fOoB(f+i-b)) z[i] = ninja[f+i-b].z;
  for (int i = 0; i < s; i++)
    if (fOoB(f+i)) ninja[f+i].z = z[i];
  Fadvance(b); 
}

boolean fOoB(int n) {
  if (n < 0 || n >= ninja.length) return false;
  else return true;
}

void MoveEdit(int m) {
  if (ninja[f].z == 256.0) {ninja[f].z = moves[0][2];}
  for (int i = 0; i < moves[0].length; i++) {
    if (int(ninja[f].z) == moves[0][i]) {
      m = constrain(m+=i, 0, 4);
      ninja[f].z = moves[0][m];
      break;
    }
  }
}

void BirdLo(boolean inc) {
  if (inc) birdxlo += 16;
  else     birdxlo -= 16;
  birdxlo &= 0xff;
  ResetVars();
}
