local tostring,gcinfo,os,ppu,pairs,winapi,assert,joypad,tonumber,io,movie,module,taseditor,coroutine,rom,loadstring,BIT,addressof,cdlog,string,debugger,package,iup,_VERSION,table,require,setmetatable,next,copytable,ipairs,memory,rawequal=tostring,gcinfo,os,ppu,pairs,winapi,assert,joypad,tonumber,io,movie,module,taseditor,coroutine,rom,loadstring,BIT,addressof,cdlog,string,debugger,package,iup,_VERSION,table,require,setmetatable,next,copytable,ipairs,memory,rawequal
local im,collectgarbage,arg,newproxy,sound,rawset,emu,xpcall,gethash,print,cd,bit,math,unpack,pcall,zapper,getfenv,type,load,tobitstring,select,gui,getmetatable,rawget,savestate,setfenv,tmp,dofile,input,debug,error,loadfile=im,collectgarbage,arg,newproxy,sound,rawset,emu,xpcall,gethash,print,cd,bit,math,unpack,pcall,zapper,getfenv,type,load,tobitstring,select,gui,getmetatable,rawget,savestate,setfenv,tmp,dofile,input,debug,error,loadfile

local rb = memory.readbyte
local rw = memory.readword
local wb = memory.writebyte
local rbs = memory.readbytesigned
local rws = memory.readwordsigned
local prb = ppu.readbyte
local getreg = memory.getregister
local setreg = memory.setregister
local memreg = memory.register
local memexec = memory.registerexec
local band = bit.band
local rshift = bit.rshift
local BIT = BIT
local hex = bit.tohex
local sf = string.format
local txt = gui.text
local pix = gui.pixel
local box = gui.box
local line = gui.line


local path = "\data\\" -- fill in the blank
local fstr = ""
for i = 1,10 do fstr = fstr.."%d\n" end
local xmoves, ymoves, bgc, str, file = "", "", "", ""
local bs      = 6   -- Bird Slot: where will the bird of interest be?
local stop    = 35838 -- frame to auto stop and commit output to file
local frame   = 0   -- starting frame
local ryuVel  = 0
local ryuPos  = 0
local screen  = 0
local birdxlo = 0
local birdPos = 0
local roomSize= 0
local birdVel = 0
local screenP = 0
local loading = false  -- true every 16 pixels scrolled (0x1000's digit of screen changes)
local scroll  = true
local bird    = false
local goleft  = 0  -- offset load seams for R-to-L scrolling rooms ($3d.7)
local birdY   = 0
local ready   = false


local function FindBird()
  for i = 7,0,-1 do 
    if rb(0x400+i) == 0xB then return i end end
  return 5
end

local xPosLast = 0
local function SetVars()
  -- bs        = FindBird()
  bird      = true
  goleft    = band(rb(0x3D),0x80)==0x80 and 0x900 or 0
  ryuPos    =  rw(0x85)
  screen    = rws(0x51)*0x100 + rb(0x50)
  xPosLast  = screen+ryuPos
  roomSize  =  rb(0x53)*0x10000
  birdVel   = rws(0x448+bs,0x450+bs)
  birdxlo   =  rb(0x458+bs)
  birdPos   =  rb(0x460+bs)*0x100 -- output separately...
  birdY     =  rb(0x480+bs)
  frame     = emu.framecount()

  xmoves, ymoves, bgc = "", "", ""  -- fresh start
  str = fstr:format(
        birdxlo,ryuPos,screen,roomSize,goleft,
        screenP,birdPos,birdY,birdVel,frame)..
        tostring(loading).."\n"..tostring(scroll).."\n"

  birdPos = birdPos+birdxlo  -- ...then combine here
end

local function GameCompare()
  local gsc = rw(0x51)*0x100 + rb(0x50)
  local gbp = rw(0x458+bs,0x460+bs)
  local gbv = rws(0x448+bs,0x450+bs)
  local grp = rw(0x85)
  ready = (gsc == screen)
  local g = (gbp == birdPos) and 'black' or 'red'

  txt(80,202, hex(gsc,5)..' ' ..hex(screen,5) ..'\n '..
              hex(gbp,4)..'  '..hex(birdPos,4)..'\n '..
              hex(gbv,4)..'  '..hex(birdVel,4)..'\n '..
              hex(grp,4)..'  '..hex(ryuPos,4),'white',g)
end


local function GetSpeed()
  local xposAbs  = rws(0x051)*0x100 + rb(0x050) + rw(0x85)
  local xspd     = xposAbs-xPosLast
  xPosLast = xposAbs
  xmoves = xmoves..sf("%d,",xspd)
  ymoves = ymoves..sf("%d,",rb(0x8A))
  return xspd
end

local function GameLoop()
  -- [Ryu movement/scrolling here]
  -- just assume he can move/scroll +/-0x180 at any time
  --  and -0x080 if moving left, then optionally sustain +/-0x080
  -- (oh yeah, not moving is also an option.)
  -- and totally disregard the option of 0x100 after taking a hit? yeah.

  ryuVel = GetSpeed()   -- 1. ~ebee
  -- or nevermind all that and get it straight from the game to test.

  if (scroll) then
    screen = screen + ryuVel      -- 2. ~f21c or ~f350
    birdPos = birdPos - ryuVel    -- 3. ~f27b or ~f3ad
  else 
    ryuPos = ryuPos + ryuVel   -- still inaccurate to scroll transition
  end

  loading = (band(screen-goleft,0xf000) ~= screenP)   -- 4. ~f2dd 
  scroll  = (screen < roomSize) and (screen >= 0)
  screenP = band(screen-goleft,0xf000)

  if (not loading) and bird then
    if (birdPos >= ryuPos) then -- first comes acceleration
      birdVel = birdVel - 16
    else
      birdVel = birdVel + 16
    end
    birdPos = birdPos + birdVel -- then movement
    if (birdPos < 0x0800) or (birdPos >= 0xf800) then bird = false end
  end

  GameCompare()
end


function ViewBG()
  bgc = sf("%d,", rws(0x51)*0x100)

  function DrawBG(arg,offset,x,y)
    bgc = bgc..sf("%d,%d,",x,y)
    -- feos, 2014
    local color2 = "#00ff00ff"
    local b = 15
    local function bgbox(color,text)
      box(x,y+offset,x+b,y+offset+b,color)
      if (text == 1) then
        txt(x+1,y+offset+1,sf("%d",arg))
      end
    end
    local function bgline(up,down,left,right)
      if (up    == 1) then line(x  ,y+offset  ,x+b,y+offset  ,color2) end
      if (down  == 1) then line(x  ,y+offset+b,x+b,y+offset  ,color2) end
      if (left  == 1) then line(x  ,y+offset  ,x  ,y+offset+b,color2) end
      if (right == 1) then line(x+b,y+offset  ,x+b,y+offset+b,color2) end
    end
    if       (arg == 1) then bgline(0,0,0,1) -- right wall
      elseif (arg == 2) then bgline(0,0,1,0) -- left wall
      elseif (arg == 3) then bgline(0,0,1,1) -- two-sided wall
      elseif (arg == 4) then bgline(1,0,0,1) -- right corner
      elseif (arg == 5) then bgline(1,0,1,0) -- left corner
      elseif (arg == 6) then bgline(1,0,1,1) -- two-sided corner
      elseif (arg == 7) then bgline(1,0,0,0) -- floor
      elseif (arg == 8) then bgbox("#ff000066",0) -- ejecting block
      elseif (arg == 9) then bgbox("#00ff0000",0) -- ladder
      elseif (arg >= 12) and (arg <= 15)
      then bgbox("#ffffff66",0) -- exits
      else bgbox("#0000ff66",1)
    end
  end

  local x_off = band(rb(0xa3),0xf)
  local c_off = rb(0x5f)
  local b, base = 15, 0x300

  for c = 0, 15 do
    local col = (c*6+c_off)%0xc0 + base
    local x, y = c*16-x_off, 64
    for row = 0, 5 do
      local tile = rb(col+row)
      local hi = rshift(tile,4)
      local lo = band(tile,0xF)
      if hi > 0 then DrawBG(hi,0,x,y) end
      if lo > 0 then DrawBG(lo,0,x,y+16) end
      y = y+32
    end
  end
end

local function WriteFile()
  -- if (not ready) then return end
  ready = false
  emu.pause()
  file = io.open(path.."birdOut.txt", "wb")
  str = str..xmoves.."\n"..ymoves.."\n"..bgc
  file:write(str)
  file:close()
end

memexec(0xC0BB, ViewBG)
memexec(0xE5F0, function()
  if getreg('a')==0xB then txt(26,16,"BIRD SPAWN FRAME") end end)
emu.registerafter(GameLoop)


local pk, kp = {}, {}
local function Pr(b) return kp[b] and not pk[b] end
while true do
  pk, kp = kp, input.get()
  if Pr('X') then SetVars() end
  if Pr('S') or emu.framecount() == stop then WriteFile() end
  emu.frameadvance()
end


--[[  Bird Acceleration
07:C76D: 38        SEC
07:C76E: BD 60 04  LDA $0460 x_pos_hi,X
07:C771: E5 86     SBC $86 ryu_xpos_hi
07:C773: 90 18     BCC $C78D
birdPos >= ryuPos:
07:C775: 38        SEC
07:C776: BD 48 04  LDA $0448 x_speed_lo,X
07:C779: E9 10     SBC #$10
07:C77B: 9D 48 04  STA $0448 x_speed_lo,X
07:C77E: BD 50 04  LDA $0450 x_speed_hi,X
07:C781: E9 00     SBC #$00
07:C783: 9D 50 04  STA $0450 x_speed_hi,X
07:C786: A5 7A     LDA $7A sprite_attr_tmp
07:C788: 09 40     ORA #$40
07:C78A: 85 7A     STA $7A sprite_attr_tmp
07:C78C: 60        RTS --------------------------------
birdPos < ryuPos:
07:C78D: 18        CLC
07:C78E: BD 48 04  LDA $0448 x_speed_lo,X
07:C791: 69 10     ADC #$10
07:C793: 9D 48 04  STA $0448 x_speed_lo,X
07:C796: BD 50 04  LDA $0450 x_speed_hi,X
07:C799: 69 00     ADC #$00
07:C79B: 9D 50 04  STA $0450 x_speed_hi,X
07:C79E: A5 7A     LDA $7A sprite_attr_tmp
07:C7A0: 29 BF     AND #$BF
07:C7A2: 85 7A     STA $7A sprite_attr_tmp
07:C7A4: 60        RTS --------------------------------
]]